import { BoundExperimentalHardhatNetworkMessageTraceHook } from "../../../../types";
import { HardhatNode } from "../node";
import { ForkConfig } from "../node-types";
import { ModulesLogger } from "./logger";
export declare class HardhatModule {
    private readonly _node;
    private readonly _resetCallback;
    private readonly _setLoggingEnabledCallback;
    private readonly _logger;
    private readonly _experimentalHardhatNetworkMessageTraceHooks;
    constructor(_node: HardhatNode, _resetCallback: (forkConfig?: ForkConfig) => Promise<void>, _setLoggingEnabledCallback: (loggingEnabled: boolean) => void, _logger: ModulesLogger, _experimentalHardhatNetworkMessageTraceHooks?: BoundExperimentalHardhatNetworkMessageTraceHook[]);
    processRequest(method: string, params?: any[]): Promise<any>;
    private _getStackTraceFailuresCountParams;
    private _getStackTraceFailuresCountAction;
    private _addCompilationResultParams;
    private _addCompilationResultAction;
    private _impersonateParams;
    private _impersonateAction;
    private _intervalMineParams;
    private _intervalMineAction;
    private _getAutomine;
    private _stopImpersonatingParams;
    private _stopImpersonatingAction;
    private _resetParams;
    private _resetAction;
    private _setLoggingEnabledParams;
    private _setLoggingEnabledAction;
    private _setMinGasPriceParams;
    private _setMinGasPriceAction;
    private _dropTransactionParams;
    private _dropTransactionAction;
    private _metadataParams;
    private _metadataAction;
    private _setBalanceParams;
    private _setBalanceAction;
    private _setCodeParams;
    private _setCodeAction;
    private _setNonceParams;
    private _setNonceAction;
    private _setStorageAtParams;
    private _setStorageAtAction;
    private _setNextBlockBaseFeePerGasParams;
    private _setNextBlockBaseFeePerGasAction;
    private _setCoinbaseParams;
    private _setCoinbaseAction;
    private _hardhatMineAction;
    private _hardhatMineParams;
    private _hardhatSetPrevRandaoParams;
    private _hardhatSetPrevRandaoAction;
    private _logBlock;
    private _runHardhatNetworkMessageTraceHooks;
    private _logHardhatMinedBlock;
}
//# sourceMappingURL=hardhat.d.ts.map